import * as i0 from '@angular/core';
import { Component, Input, NgModule, EventEmitter, Output } from '@angular/core';
import { CommonModule } from '@angular/common';
import { __classPrivateFieldGet, __classPrivateFieldSet } from 'tslib';
import * as i2 from '@angular/forms';
import { FormsModule } from '@angular/forms';

class CodeEditorComponent {
    constructor() {
        this.placeholder = 'need professionals help';
        this.contentWidth = 800;
        this.contentHeight = 600;
    }
}
CodeEditorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CodeEditorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: CodeEditorComponent, selector: "ngx-code-editor", inputs: { placeholder: "placeholder", contentWidth: "contentWidth", contentHeight: "contentHeight" }, ngImport: i0, template: "<div class=\"editor-wrapper\">\n  <div id=\"ngx-code-editor-container\" class=\"editor-wrapper-content\" [style.width.px]=\"contentWidth\" [style.height.px]=\"contentHeight\">\n    <!--        <div class=\"editor-wrapper-placeholder\">{{placeholder}}</div>-->\n  </div>\n</div>\n", styles: [".editor-wrapper{position:relative}.editor-wrapper-content{border:1px solid grey}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-code-editor', template: "<div class=\"editor-wrapper\">\n  <div id=\"ngx-code-editor-container\" class=\"editor-wrapper-content\" [style.width.px]=\"contentWidth\" [style.height.px]=\"contentHeight\">\n    <!--        <div class=\"editor-wrapper-placeholder\">{{placeholder}}</div>-->\n  </div>\n</div>\n", styles: [".editor-wrapper{position:relative}.editor-wrapper-content{border:1px solid grey}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { placeholder: [{
                type: Input
            }], contentWidth: [{
                type: Input
            }], contentHeight: [{
                type: Input
            }] } });

class CodeEditorModule {
}
CodeEditorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CodeEditorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, declarations: [CodeEditorComponent], imports: [CommonModule], exports: [CodeEditorComponent] });
CodeEditorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [CodeEditorComponent],
                    exports: [CodeEditorComponent]
                }]
        }] });

const regPrefix = /^([^/:]+):\/*/;
const urlJoin = (...paths) => {
    paths = paths.filter(d => d !== '');
    if (paths.length === 0) {
        return '';
    }
    const findIndex = paths.findIndex(d => !(typeof d !== 'string' || typeof d !== 'number'));
    if (findIndex >= 0) {
        throw new Error('paths must be a string or number');
    }
    let prefix = '';
    const firstPath = `${paths[0]}`;
    if (firstPath.startsWith('//')) {
        prefix = '//';
    }
    else if (firstPath.startsWith('/')) {
        prefix = '/';
    }
    else {
        if (firstPath.startsWith('file:') && paths.length > 1 && (firstPath + paths[1]).match(/^file:\/\/\//)) {
            prefix = firstPath.replace(regPrefix, '$1:///');
        }
        else {
            prefix = firstPath.replace(regPrefix, '$1://');
        }
        paths.shift();
    }
    if (prefix && !prefix.endsWith('/')) {
        prefix += '/';
    }
    let pathStr = paths
        .map(path => `${path}`
        .replace(/^\/+/, '')
        .replace(/^\.\/+/, '')
        .replace(/\/+$/, ''))
        .filter(d => d !== '')
        .join('/');
    while (pathStr.includes('/../')) {
        const pathArr = pathStr.split('/');
        const index = pathArr.findIndex(d => d === '..');
        pathArr.splice(index - 1, 2);
        pathStr = pathArr.join('/');
    }
    let backStr = prefix + pathStr;
    if (backStr.includes('?')) {
        const parts = backStr.split('?').filter(d => d !== '');
        backStr = parts.shift() + '?';
        if (parts.length > 0) {
            backStr += parts.join('&');
        }
    }
    return backStr.replace(/\/(\?|&|#[^!])/g, '$1');
};

var _LoadMonacoEditor_load;
// noinspection TypeScriptUnresolvedVariable
/**
 * moaco loader
 */
class LoadMonacoEditor {
    constructor(baseUrl, language, theme, defaultValue, localizeCode) {
        this.baseUrl = baseUrl;
        this.language = language;
        this.theme = theme;
        this.defaultValue = defaultValue;
        this.localizeCode = localizeCode;
        _LoadMonacoEditor_load.set(this, void 0);
        this.supportLanguages = ['de', 'es', 'fr', 'it', 'ja', 'ko', 'ru', 'zh-cn', 'zh-tw'];
    }
    /**
     * the language in current nation
     * @protected
     */
    currentLanguage() {
        try {
            const lang = navigator.language.toLocaleLowerCase();
            const findLang = this.supportLanguages.find(l => lang === l) || '';
            if (lang && !findLang) {
                console.error(`not support language ${lang}`);
            }
            return findLang;
        }
        catch (error) {
            console.error(error);
            return '';
        }
    }
    load() {
        if (!__classPrivateFieldGet(this, _LoadMonacoEditor_load, "f")) {
            __classPrivateFieldSet(this, _LoadMonacoEditor_load, new Promise(resolve => {
                const win = window;
                if (typeof win.monaco === 'object') {
                    resolve();
                    return;
                }
                const onGotAMDLoader = () => {
                    win.require.config({
                        paths: {
                            vs: 'monaco-editor/min/vs',
                            tokenizer: 'monaco-ace-tokenizer/dist'
                        },
                        'vs/nls': {
                            availableLanguages: {
                                '*': this.localizeCode || this.currentLanguage()
                            }
                        }
                    });
                    win.require(['vs/editor/editor.main', 'tokenizer/monaco-tokenizer', 'tokenizer/definitions/groovy'], (a, MonacoAceTokenizer, GroovyDefinition) => {
                        win.monaco.languages.register({
                            id: 'groovy'
                        });
                        MonacoAceTokenizer.registerRulesForLanguage('groovy', new GroovyDefinition.default());
                        win.rgCodeEditor = win.monaco.editor.create(document.getElementById('ngx-code-editor-container'), {
                            value: this.defaultValue,
                            language: this.language,
                            theme: this.theme
                        });
                        // /* To load All languages */
                        // win.require(['vs/editor/editor.main', 'tokenizer/monaco-tokenizer'], (_: any, MonacoAceTokenizer: any) =>{
                        //   MonacoAceTokenizer.AVAILABLE_LANGUAGES.forEach((lang: string) => {
                        //     win.require(['tokenizer/definitions/' + lang], (LangDefinition: any) =>{
                        //       win.monaco.languages.register({
                        //         id: lang,
                        //       });
                        //       MonacoAceTokenizer.registerRulesForLanguage(lang, new LangDefinition.default);
                        //     });
                        //   });
                        // });
                        resolve();
                    });
                };
                if (!win.require) {
                    const loaderScript = document.createElement('script');
                    loaderScript.id = 'ngx-code-editor-load-monaco-script';
                    loaderScript.type = 'text/javascript';
                    loaderScript.src = urlJoin(this.baseUrl, '/monaco-editor/min/vs/loader.js');
                    loaderScript.addEventListener('load', onGotAMDLoader);
                    document.body.appendChild(loaderScript);
                }
                else {
                    onGotAMDLoader();
                }
            }), "f");
        }
        return __classPrivateFieldGet(this, _LoadMonacoEditor_load, "f");
    }
}
_LoadMonacoEditor_load = new WeakMap();

const BASE_MONACO_URL = '';
/**
 * get default url
 * @param baseUrl default url
 */
const getBaseMonacoUrl = (baseUrl) => baseUrl || '' || BASE_MONACO_URL;

let loader;
class CodeEditorAppComponent {
    constructor() {
        /* default code language */
        this.language = 'java';
        /* default theme */
        this.theme = 'vs';
        /* width of conetnt area need a fixed value */
        this.contentWidth = 800;
        /* height of conetnt area need a fixed value */
        this.contentHeight = 600;
        // Event when the value of conetnt change
        this.contentChange = new EventEmitter();
        /* the label of switch language */
        this.languageLabel = 'CodeLanguages';
        /* the label of switch theme */
        this.themeLabel = 'Themes';
    }
    async ngOnInit() {
        const baseUrl = getBaseMonacoUrl(this.baseUrl);
        if (!loader) {
            loader = new LoadMonacoEditor(baseUrl, this.language, this.theme, this.defaultValue, this.localizeCode);
        }
        await loader.load();
        // listen the change of keyUp and output the value
        const win = window;
        win.rgCodeEditor.onKeyUp((res) => {
            this.contentChange.next(res?.target?.value);
        });
    }
    /**
     * switch theme
     */
    themeChange() {
        const win = window;
        win.monaco.editor.setTheme(this.theme);
    }
    /**
     * switch code language
     */
    languageChange() {
        const win = window;
        win.monaco.editor.setModelLanguage(win.rgCodeEditor.getModel(), this.language);
    }
    /**
     * get current code value
     */
    getValue() {
        const win = window;
        const value = win.rgCodeEditor.getValue();
        return value;
    }
}
CodeEditorAppComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CodeEditorAppComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: CodeEditorAppComponent, selector: "ngx-code-editor-app", inputs: { baseUrl: "baseUrl", localizeCode: "localizeCode", language: "language", theme: "theme", defaultValue: "defaultValue", contentWidth: "contentWidth", contentHeight: "contentHeight", languageLabel: "languageLabel", themeLabel: "themeLabel" }, outputs: { contentChange: "contentChange" }, ngImport: i0, template: "<div class=\"section-row\">\n  <div class=\"section-row-item\">\n    <div class=\"section-row-item-label\">\n      {{languageLabel}}\uFF1A\n    </div>\n    <div class=\"section-row-item-value\">\n      <select [(ngModel)]=\"language\" (ngModelChange)=\"languageChange()\">\n        <option value=\"java\">java</option>\n        <option value=\"javascript\">javascript</option>\n        <option value=\"json\">json</option>\n        <option value=\"sql\">sql</option>\n        <option value=\"groovy\">groovy</option>\n        <option value=\"plaintext\">plaintext</option>\n        <option value=\"abap\">abap</option>\n        <option value=\"apex\">apex</option>\n        <option value=\"azcli\">azcli</option>\n        <option value=\"bat\">bat</option>\n        <option value=\"bicep\">bicep</option>\n        <option value=\"cameligo\">cameligo</option>\n        <option value=\"clojure\">clojure</option>\n        <option value=\"coffeescript\">coffeescript</option>\n        <option value=\"c\">c</option>\n        <option value=\"cpp\">cpp</option>\n        <option value=\"csharp\">csharp</option>\n        <option value=\"csp\">csp</option>\n        <option value=\"css\">css</option>\n        <option value=\"dart\">dart</option>\n        <option value=\"dockerfile\">dockerfile</option>\n        <option value=\"ecl\">ecl</option>\n        <option value=\"elixir\">elixir</option>\n        <option value=\"flow9\">flow9</option>\n        <option value=\"fsharp\">fsharp</option>\n        <option value=\"go\">go</option>\n        <option value=\"graphql\">graphql</option>\n        <option value=\"handlebars\">handlebars</option>\n        <option value=\"hcl\">hcl</option>\n        <option value=\"html\">html</option>\n        <option value=\"ini\">ini</option>\n        <option value=\"julia\">julia</option>\n        <option value=\"kotlin\">kotlin</option>\n        <option value=\"less\">less</option>\n        <option value=\"lexon\">lexon</option>\n        <option value=\"liquid\">liquid</option>\n        <option value=\"lua\">lua</option>\n        <option value=\"m3\">m3</option>\n        <option value=\"markdown\">markdown</option>\n        <option value=\"mips\">mips</option>\n        <option value=\"msdax\">msdax</option>\n        <option value=\"mysql\">mysql</option>\n        <option value=\"objective-c\">objective-c</option>\n        <option value=\"pascal\">pascal</option>\n        <option value=\"pascaligo\">pascaligo</option>\n        <option value=\"perl\">perl</option>\n        <option value=\"pgsql\">pgsql</option>\n        <option value=\"php\">php</option>\n        <option value=\"pla\">pla</option>\n        <option value=\"postiats\">postiats</option>\n        <option value=\"powerquery\">powerquery</option>\n        <option value=\"powershell\">powershell</option>\n        <option value=\"proto\">proto</option>\n        <option value=\"pug\">pug</option>\n        <option value=\"python\">python</option>\n        <option value=\"qsharp\">qsharp</option>\n        <option value=\"r\">r</option>\n        <option value=\"razor\">razor</option>\n        <option value=\"redis\">redis</option>\n        <option value=\"redshift\">redshift</option>\n        <option value=\"restructuredtext\">restructuredtext</option>\n        <option value=\"ruby\">ruby</option>\n        <option value=\"rust\">rust</option>\n        <option value=\"sb\">sb</option>\n        <option value=\"scala\">scala</option>\n        <option value=\"scheme\">scheme</option>\n        <option value=\"scss\">scss</option>\n        <option value=\"shell\">shell</option>\n        <option value=\"sol\">sol</option>\n        <option value=\"aes\">aes</option>\n        <option value=\"sparql\">sparql</option>\n        <option value=\"st\">st</option>\n        <option value=\"swift\">swift</option>\n        <option value=\"systemverilog\">systemverilog</option>\n        <option value=\"verilog\">verilog</option>\n        <option value=\"tcl\">tcl</option>\n        <option value=\"twig\">twig</option>\n        <option value=\"typescript\">typescript</option>\n        <option value=\"vb\">vb</option>\n        <option value=\"xml\">xml</option>\n        <option value=\"yaml\">yaml</option>\n        <option value=\"ada\">ada</option>\n        <option value=\"cobol\">cobol</option>\n        <option value=\"d\">d</option>\n        <option value=\"dart\">dart</option>\n        <option value=\"elixir\">elixir</option>\n        <option value=\"erlang\">erlang</option>\n        <option value=\"fortran\">fortran</option>\n        <option value=\"haskell\">haskell</option>\n        <option value=\"julia\">julia</option>\n        <option value=\"ocaml\">ocaml</option>\n        <option value=\"racket\">racket</option>\n        <option value=\"sbcl\">sbcl</option>\n        <option value=\"scala\">scala</option>\n      </select>\n    </div>\n  </div>\n  <div class=\"section-row-item\">\n    <div class=\"section-row-item-label\">\n      {{themeLabel}}\uFF1A\n    </div>\n    <div class=\"section-row-item-value\">\n      <select [(ngModel)]=\"theme\" (ngModelChange)=\"themeChange()\">\n        <option value=\"vs\">VS</option>\n        <option value=\"vs-dark\">VS Dark</option>\n        <option value=\"hc-black\">High Contrast (Dark)</option>\n        <!--  <option value=\"active4d\">Active4D</option>-->\n        <!--  <option value=\"all-hallows-eve\">All Hallows Eve</option>-->\n        <!--  <option value=\"amy\">Amy</option>-->\n        <!--  <option value=\"birds-of-paradise\">Birds of Paradise</option>-->\n        <!--  <option value=\"blackboard\">Blackboard</option>-->\n        <!--  <option value=\"brilliance-black\">Brilliance Black</option>-->\n        <!--  <option value=\"brilliance-dull\">Brilliance Dull</option>-->\n        <!--  <option value=\"chrome-devtools\">Chrome DevTools</option>-->\n        <!--  <option value=\"clouds-midnight\">Clouds Midnight</option>-->\n        <!--  <option value=\"clouds\">Clouds</option>-->\n        <!--  <option value=\"cobalt\">Cobalt</option>-->\n        <!--  <option value=\"dawn\">Dawn</option>-->\n        <!--  <option value=\"dracula\">Dracula</option>-->\n        <!--  <option value=\"dreamweaver\">Dreamweaver</option>-->\n        <!--  <option value=\"eiffel\">Eiffel</option>-->\n        <!--  <option value=\"espresso-libre\">Espresso Libre</option>-->\n        <!--  <option value=\"github\">GitHub</option>-->\n        <!--  <option value=\"idle\">IDLE</option>-->\n        <!--  <option value=\"katzenmilch\">Katzenmilch</option>-->\n        <!--  <option value=\"kuroir-theme\">Kuroir Theme</option>-->\n        <!--  <option value=\"lazy\">LAZY</option>-->\n        <!--  <option value=\"magicwb&#45;&#45;amiga-\">MagicWB (Amiga)</option>-->\n        <!--  <option value=\"merbivore-soft\">Merbivore Soft</option>-->\n        <!--  <option value=\"merbivore\">Merbivore</option>-->\n        <!--  <option value=\"monokai-bright\">Monokai Bright</option>-->\n        <!--  <option value=\"monokai\">Monokai</option>-->\n        <!--  <option value=\"night-owl\">Night Owl</option>-->\n        <!--  <option value=\"oceanic-next\">Oceanic Next</option>-->\n        <!--  <option value=\"pastels-on-dark\">Pastels on Dark</option>-->\n        <!--  <option value=\"slush-and-poppies\">Slush and Poppies</option>-->\n        <!--  <option value=\"solarized-dark\">Solarized-dark</option>-->\n        <!--  <option value=\"solarized-light\">Solarized-light</option>-->\n        <!--  <option value=\"spacecadet\">SpaceCadet</option>-->\n        <!--  <option value=\"sunburst\">Sunburst</option>-->\n        <!--  <option value=\"textmate&#45;&#45;mac-classic-\">Textmate (Mac Classic)</option>-->\n        <!--  <option value=\"tomorrow-night-blue\">Tomorrow-Night-Blue</option>-->\n        <!--  <option value=\"tomorrow-night-bright\">Tomorrow-Night-Bright</option>-->\n        <!--  <option value=\"tomorrow-night-eighties\">Tomorrow-Night-Eighties</option>-->\n        <!--  <option value=\"tomorrow-night\">Tomorrow-Night</option>-->\n        <!--  <option value=\"tomorrow\">Tomorrow</option>-->\n        <!--  <option value=\"twilight\">Twilight</option>-->\n        <!--  <option value=\"upstream-sunburst\">Upstream Sunburst</option>-->\n        <!--  <option value=\"vibrant-ink\">Vibrant Ink</option>-->\n        <!--  <option value=\"xcode-default\">Xcode_default</option>-->\n        <!--  <option value=\"zenburnesque\">Zenburnesque</option>-->\n        <!--  <option value=\"iplastic\">iPlastic</option>-->\n        <!--  <option value=\"idlefingers\">idleFingers</option>-->\n        <!--  <option value=\"krtheme\">krTheme</option>-->\n        <!--  <option value=\"monoindustrial\">monoindustrial</option>-->\n      </select>\n    </div>\n  </div>\n</div>\n<ngx-code-editor [contentWidth]=\"contentWidth\" [contentHeight]=\"contentHeight\"></ngx-code-editor>\n", styles: [".section-row,.section-row-item{display:flex;flex-direction:row;align-items:center}\n"], components: [{ type: CodeEditorComponent, selector: "ngx-code-editor", inputs: ["placeholder", "contentWidth", "contentHeight"] }], directives: [{ type: i2.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-code-editor-app', template: "<div class=\"section-row\">\n  <div class=\"section-row-item\">\n    <div class=\"section-row-item-label\">\n      {{languageLabel}}\uFF1A\n    </div>\n    <div class=\"section-row-item-value\">\n      <select [(ngModel)]=\"language\" (ngModelChange)=\"languageChange()\">\n        <option value=\"java\">java</option>\n        <option value=\"javascript\">javascript</option>\n        <option value=\"json\">json</option>\n        <option value=\"sql\">sql</option>\n        <option value=\"groovy\">groovy</option>\n        <option value=\"plaintext\">plaintext</option>\n        <option value=\"abap\">abap</option>\n        <option value=\"apex\">apex</option>\n        <option value=\"azcli\">azcli</option>\n        <option value=\"bat\">bat</option>\n        <option value=\"bicep\">bicep</option>\n        <option value=\"cameligo\">cameligo</option>\n        <option value=\"clojure\">clojure</option>\n        <option value=\"coffeescript\">coffeescript</option>\n        <option value=\"c\">c</option>\n        <option value=\"cpp\">cpp</option>\n        <option value=\"csharp\">csharp</option>\n        <option value=\"csp\">csp</option>\n        <option value=\"css\">css</option>\n        <option value=\"dart\">dart</option>\n        <option value=\"dockerfile\">dockerfile</option>\n        <option value=\"ecl\">ecl</option>\n        <option value=\"elixir\">elixir</option>\n        <option value=\"flow9\">flow9</option>\n        <option value=\"fsharp\">fsharp</option>\n        <option value=\"go\">go</option>\n        <option value=\"graphql\">graphql</option>\n        <option value=\"handlebars\">handlebars</option>\n        <option value=\"hcl\">hcl</option>\n        <option value=\"html\">html</option>\n        <option value=\"ini\">ini</option>\n        <option value=\"julia\">julia</option>\n        <option value=\"kotlin\">kotlin</option>\n        <option value=\"less\">less</option>\n        <option value=\"lexon\">lexon</option>\n        <option value=\"liquid\">liquid</option>\n        <option value=\"lua\">lua</option>\n        <option value=\"m3\">m3</option>\n        <option value=\"markdown\">markdown</option>\n        <option value=\"mips\">mips</option>\n        <option value=\"msdax\">msdax</option>\n        <option value=\"mysql\">mysql</option>\n        <option value=\"objective-c\">objective-c</option>\n        <option value=\"pascal\">pascal</option>\n        <option value=\"pascaligo\">pascaligo</option>\n        <option value=\"perl\">perl</option>\n        <option value=\"pgsql\">pgsql</option>\n        <option value=\"php\">php</option>\n        <option value=\"pla\">pla</option>\n        <option value=\"postiats\">postiats</option>\n        <option value=\"powerquery\">powerquery</option>\n        <option value=\"powershell\">powershell</option>\n        <option value=\"proto\">proto</option>\n        <option value=\"pug\">pug</option>\n        <option value=\"python\">python</option>\n        <option value=\"qsharp\">qsharp</option>\n        <option value=\"r\">r</option>\n        <option value=\"razor\">razor</option>\n        <option value=\"redis\">redis</option>\n        <option value=\"redshift\">redshift</option>\n        <option value=\"restructuredtext\">restructuredtext</option>\n        <option value=\"ruby\">ruby</option>\n        <option value=\"rust\">rust</option>\n        <option value=\"sb\">sb</option>\n        <option value=\"scala\">scala</option>\n        <option value=\"scheme\">scheme</option>\n        <option value=\"scss\">scss</option>\n        <option value=\"shell\">shell</option>\n        <option value=\"sol\">sol</option>\n        <option value=\"aes\">aes</option>\n        <option value=\"sparql\">sparql</option>\n        <option value=\"st\">st</option>\n        <option value=\"swift\">swift</option>\n        <option value=\"systemverilog\">systemverilog</option>\n        <option value=\"verilog\">verilog</option>\n        <option value=\"tcl\">tcl</option>\n        <option value=\"twig\">twig</option>\n        <option value=\"typescript\">typescript</option>\n        <option value=\"vb\">vb</option>\n        <option value=\"xml\">xml</option>\n        <option value=\"yaml\">yaml</option>\n        <option value=\"ada\">ada</option>\n        <option value=\"cobol\">cobol</option>\n        <option value=\"d\">d</option>\n        <option value=\"dart\">dart</option>\n        <option value=\"elixir\">elixir</option>\n        <option value=\"erlang\">erlang</option>\n        <option value=\"fortran\">fortran</option>\n        <option value=\"haskell\">haskell</option>\n        <option value=\"julia\">julia</option>\n        <option value=\"ocaml\">ocaml</option>\n        <option value=\"racket\">racket</option>\n        <option value=\"sbcl\">sbcl</option>\n        <option value=\"scala\">scala</option>\n      </select>\n    </div>\n  </div>\n  <div class=\"section-row-item\">\n    <div class=\"section-row-item-label\">\n      {{themeLabel}}\uFF1A\n    </div>\n    <div class=\"section-row-item-value\">\n      <select [(ngModel)]=\"theme\" (ngModelChange)=\"themeChange()\">\n        <option value=\"vs\">VS</option>\n        <option value=\"vs-dark\">VS Dark</option>\n        <option value=\"hc-black\">High Contrast (Dark)</option>\n        <!--  <option value=\"active4d\">Active4D</option>-->\n        <!--  <option value=\"all-hallows-eve\">All Hallows Eve</option>-->\n        <!--  <option value=\"amy\">Amy</option>-->\n        <!--  <option value=\"birds-of-paradise\">Birds of Paradise</option>-->\n        <!--  <option value=\"blackboard\">Blackboard</option>-->\n        <!--  <option value=\"brilliance-black\">Brilliance Black</option>-->\n        <!--  <option value=\"brilliance-dull\">Brilliance Dull</option>-->\n        <!--  <option value=\"chrome-devtools\">Chrome DevTools</option>-->\n        <!--  <option value=\"clouds-midnight\">Clouds Midnight</option>-->\n        <!--  <option value=\"clouds\">Clouds</option>-->\n        <!--  <option value=\"cobalt\">Cobalt</option>-->\n        <!--  <option value=\"dawn\">Dawn</option>-->\n        <!--  <option value=\"dracula\">Dracula</option>-->\n        <!--  <option value=\"dreamweaver\">Dreamweaver</option>-->\n        <!--  <option value=\"eiffel\">Eiffel</option>-->\n        <!--  <option value=\"espresso-libre\">Espresso Libre</option>-->\n        <!--  <option value=\"github\">GitHub</option>-->\n        <!--  <option value=\"idle\">IDLE</option>-->\n        <!--  <option value=\"katzenmilch\">Katzenmilch</option>-->\n        <!--  <option value=\"kuroir-theme\">Kuroir Theme</option>-->\n        <!--  <option value=\"lazy\">LAZY</option>-->\n        <!--  <option value=\"magicwb&#45;&#45;amiga-\">MagicWB (Amiga)</option>-->\n        <!--  <option value=\"merbivore-soft\">Merbivore Soft</option>-->\n        <!--  <option value=\"merbivore\">Merbivore</option>-->\n        <!--  <option value=\"monokai-bright\">Monokai Bright</option>-->\n        <!--  <option value=\"monokai\">Monokai</option>-->\n        <!--  <option value=\"night-owl\">Night Owl</option>-->\n        <!--  <option value=\"oceanic-next\">Oceanic Next</option>-->\n        <!--  <option value=\"pastels-on-dark\">Pastels on Dark</option>-->\n        <!--  <option value=\"slush-and-poppies\">Slush and Poppies</option>-->\n        <!--  <option value=\"solarized-dark\">Solarized-dark</option>-->\n        <!--  <option value=\"solarized-light\">Solarized-light</option>-->\n        <!--  <option value=\"spacecadet\">SpaceCadet</option>-->\n        <!--  <option value=\"sunburst\">Sunburst</option>-->\n        <!--  <option value=\"textmate&#45;&#45;mac-classic-\">Textmate (Mac Classic)</option>-->\n        <!--  <option value=\"tomorrow-night-blue\">Tomorrow-Night-Blue</option>-->\n        <!--  <option value=\"tomorrow-night-bright\">Tomorrow-Night-Bright</option>-->\n        <!--  <option value=\"tomorrow-night-eighties\">Tomorrow-Night-Eighties</option>-->\n        <!--  <option value=\"tomorrow-night\">Tomorrow-Night</option>-->\n        <!--  <option value=\"tomorrow\">Tomorrow</option>-->\n        <!--  <option value=\"twilight\">Twilight</option>-->\n        <!--  <option value=\"upstream-sunburst\">Upstream Sunburst</option>-->\n        <!--  <option value=\"vibrant-ink\">Vibrant Ink</option>-->\n        <!--  <option value=\"xcode-default\">Xcode_default</option>-->\n        <!--  <option value=\"zenburnesque\">Zenburnesque</option>-->\n        <!--  <option value=\"iplastic\">iPlastic</option>-->\n        <!--  <option value=\"idlefingers\">idleFingers</option>-->\n        <!--  <option value=\"krtheme\">krTheme</option>-->\n        <!--  <option value=\"monoindustrial\">monoindustrial</option>-->\n      </select>\n    </div>\n  </div>\n</div>\n<ngx-code-editor [contentWidth]=\"contentWidth\" [contentHeight]=\"contentHeight\"></ngx-code-editor>\n", styles: [".section-row,.section-row-item{display:flex;flex-direction:row;align-items:center}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { baseUrl: [{
                type: Input
            }], localizeCode: [{
                type: Input
            }], language: [{
                type: Input
            }], theme: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], contentWidth: [{
                type: Input
            }], contentHeight: [{
                type: Input
            }], contentChange: [{
                type: Output
            }], languageLabel: [{
                type: Input
            }], themeLabel: [{
                type: Input
            }] } });

class CodeEditorAppModule {
}
CodeEditorAppModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CodeEditorAppModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, declarations: [CodeEditorAppComponent], imports: [CommonModule, FormsModule, CodeEditorModule], exports: [CodeEditorAppComponent] });
CodeEditorAppModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, imports: [[CommonModule, FormsModule, CodeEditorModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CodeEditorAppComponent],
                    imports: [CommonModule, FormsModule, CodeEditorModule],
                    exports: [CodeEditorAppComponent]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { CodeEditorAppComponent, CodeEditorAppModule, CodeEditorComponent, CodeEditorModule, LoadMonacoEditor, getBaseMonacoUrl, urlJoin };
//# sourceMappingURL=ngx-code-editor.mjs.map
